//
//  YLTabBar.m
//  GoOff
//
//  Created by 石家庄盛航 on 16/4/25.
//  Copyright © 2016年 sjzshtx. All rights reserved.
//

#import "YLTabBar.h"

@interface YLTabBar()
@property (nonatomic, weak) UIButton *spurtBut;

@end
@implementation YLTabBar

- (id)initWithFrame:(CGRect)frame
{
    self = [super initWithFrame:frame];
    if (self) {
        // 添加一个按钮到tabbar中
        UIButton *spurtBut = [[UIButton alloc] init];
        [spurtBut setBackgroundImage:[UIImage imageNamed:@"spurt"] forState:UIControlStateNormal];
        spurtBut.size = spurtBut.currentBackgroundImage.size;
        [spurtBut addTarget:self action:@selector(plusClick) forControlEvents:UIControlEventTouchUpInside];
        [self addSubview:spurtBut];
        self.spurtBut = spurtBut;
     
    }
    return self;
}

/**
 *  加号按钮点击
 */
- (void)plusClick
{
    // 通知代理
    if ([self.delegate respondsToSelector:@selector(tabBarDidClickPlusButton:)]) {
        [self.delegate tabBarDidClickPlusButton:self];
    }
}

- (void)layoutSubviews
{
    [super layoutSubviews];
    // 1.设置按钮的位置
    self.spurtBut.centerX = self.width * 0.5;
    self.spurtBut.centerY = self.height * 0.5;
    // 2.设置其他tabbarButton的位置和尺寸
    CGFloat tabbarButtonW = self.width / 3;
    CGFloat tabbarButtonIndex = 0;
    for (UIView *child in self.subviews) {
        Class class = NSClassFromString(@"UITabBarButton");
        if ([child isKindOfClass:class]) {
            // 设置宽度
            child.width = tabbarButtonW;
            // 设置x
            child.x = tabbarButtonIndex * tabbarButtonW;
            // 增加索引
            tabbarButtonIndex++;
            if (tabbarButtonIndex == 1) {
                tabbarButtonIndex++;
            }
        }
    }
   
}


@end
